// Copyright © カミュプリィ (Commuply Inc.)
import java.io.*;
import java.sql.*;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import jakarta.servlet.*;
import jakarta.servlet.http.*;

public class HelloWorld extends HttpServlet {
	String url = "jdbc:mariadb://localhost:3306";
	String username = "ユーザー名";
	String userpassword = "パスワード";

	public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException, ServletException {
		DateTimeFormatter dayformat = DateTimeFormatter.ofPattern("yyyyMMdd");
		DateTimeFormatter timeformat = DateTimeFormatter.ofPattern("HHmmss");
		LocalDateTime now = LocalDateTime.now();
		String databasename = dayformat.format(now);
		String tablename = timeformat.format(now);

		response.setContentType("text/html");
		PrintWriter out = response.getWriter();
		out.println("<html lang=\"ja\">");
		out.println("<head>");
		out.println("<meta charset=\"utf-8\" >");
		out.println("<title>HelloWorld</title>");
		out.println("</head>");
		out.println("<body>");
		try {
			Connection connection = null;
			Statement statement = null;
			try {
				Class.forName("org.mariadb.jdbc.Driver");
				connection = DriverManager.getConnection(url, username, userpassword);
				statement = connection.createStatement();
			} catch(Exception e) {
				print(out, "Class.forName - createStatement", e);
			}

			try {
				statement.execute("create database `" + databasename + "`");
				out.println("<div>create database `" + databasename + "`</div>");
				statement.execute("use `" + databasename + "`");
				out.println("<div>use `" + databasename + "`</div>");
				statement.execute("create table `" + tablename + "` (`1` int PRIMARY KEY AUTO_INCREMENT, `2` varchar(15), `3` varchar(32))");
				out.println("<div>create table `" + tablename + "` (`1` int PRIMARY KEY AUTO_INCREMENT, `2` varchar(15), `3` varchar(32))</div>");
				statement.executeUpdate("INSERT INTO `" + tablename + "` (`2`, `3`) VALUES ('ABC', 'DEF')");
				out.println("<div>INSERT INTO `" + tablename + "` (`2`, `3`) VALUES ('ABC', 'DEF')</div>");
			} catch(Exception e) {
				print(out, "create", e);
			}

			ResultSet result = null;
			try {
				result = statement.executeQuery("SELECT * FROM `" + tablename + "`");
				print(out, result);
			} catch(Exception e) {
				print(out, "select", e);
			}

			try {
				statement.execute("drop database `" + databasename + "`");
				out.println("<div>drop database `" + databasename + "`</div>");
			} catch(Exception e) {
				print(out, "drop", e);
			}

			try {
				connection.close();
			} catch(Exception e) {
				print(out, "close", e);
			}
		} finally {
			out.println("</body>");
			out.println("</html>");
		}
	} // doGet

	// SQLの結果を表示
	public void print(PrintWriter out, ResultSet result) {
		if(result == null) {
			return;
		}
		int columncount = -1;
		// 見出し
		out.print("<div>");
		try {
			ResultSetMetaData rsmd = result.getMetaData();
			columncount = rsmd.getColumnCount();
			for (int i = 1; i <= columncount; i++) {
				if(i > 1) {
					out.print(", ");
				} // if
				out.print(rsmd.getColumnName(i) + "(" + rsmd.getColumnTypeName(i) + ")");
			} // for
		} catch(Exception e) {
			print(out, "print(PrintWriter, ResultSet) 見出し", e);
		}
		out.println("</div>");

		// 行
		try {
			while(result.next()) {
				out.print("<div>");
				try {
					for (int i = 1; i <= columncount; i++) {
						if(i > 1) {
							out.print(", ");
						} // if
						String s = result.getString(i);
						if(result.wasNull()) {
							s = "(NULL)";
						} else if(s.length() == 0) {
							s = "(BLANK)";
						} // if
						out.print(s);
					} // for
				} catch(Exception e) {
					print(out, "print(ResultSet) 各行", e);
				}
				out.println("</div>");
			} // while
		} catch(Exception e) {
			print(out, "print(PrintWriter, ResultSet) 行全体", e);
		}
		out.println("<div>(END OF DATA)</div>");
	} // print

	// エラーを表示
	public void print(PrintWriter out, String s, Exception e) {
		out.println("<div>ERROR " + s + " : " + e + "</div>");
		StackTraceElement[] ele = new Throwable().getStackTrace();
		for (int i = 0; i < ele.length; i++) {
			out.println("<div>" + ele[i] + "</div>");
		} // for
	} // print

} // class HelloWorld
